#include <stdio.h>

    /* gibt zahl in Binaerdarstellung mit
     * der min. Breite min_breite aus (rekursiv!) */
void print_binaer(int zahl, int min_breite) {
    if (zahl != 0 || min_breite > 0) {
	    /* rekursiv die vorderen Bits der Zahl
	     * ausgeben (mit minimaler Breite min_breite-1
	     * (Effizienz :-() */
	print_binaer(zahl >> 1, min_breite - 1);
	    /* danach noch das letzte Bit ausgeben */
	printf("%d", zahl & 1);
    }
}

int main() {
    int i = 17, j = 3;

	/* Division und Modulo (= Divisionsrest) */
    printf("i=%d, j=%d, i/j=%d, i%%j=%d\n", i, j, i / j, i % j);

    puts("----------------------------------------");

    printf("i="); print_binaer(i, 5);
    puts("");
    printf("j="); print_binaer(j, 5);
    puts("");

	/* Bitweises UND, ODER und XOR (= exklusives ODER) */
    printf("i&j="); print_binaer(i & j, 5);
    printf(", i|j="); print_binaer(i | j, 5);
    printf(", i^j="); print_binaer(i ^ j, 5);
    puts("");

	/* Bit-Verschiebungen (nicht zyklisch!) */
    printf("i>>1="); print_binaer(i >> 1, 5);
    printf(", i<<1="); print_binaer(i << 1, 5);
    puts("");

    return 0;
}
